#!/usr/bin/env node
"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var commander_1 = __importDefault(require("commander"));
var package_json_1 = require("../package.json");
var login_1 = __importDefault(require("./login"));
var logout_1 = __importDefault(require("./logout"));
var status_1 = __importDefault(require("./status"));
var run_1 = __importDefault(require("./run"));
commander_1["default"].version(package_json_1.version);
commander_1["default"].command('version').action(function () { return console.log(package_json_1.version); });
commander_1["default"]
    .command('login')
    .option('--ci', 'show token rather than saving it')
    .option('--token [token]', 'save the given token rather than prompting')
    .action(login_1["default"]);
commander_1["default"].command('logout').action(logout_1["default"]);
commander_1["default"].command('status').action(status_1["default"]);
commander_1["default"]
    .command('run <challenge_id> <executable> [arguments...]')
    .option('-l, --live', 'actually submit the result. This can not be undone and can only be done a limited amount of times')
    .action(run_1["default"]);
commander_1["default"].on('command:*', function () {
    console.error('Invalid command: %s\nSee --help for a list of available commands.', commander_1["default"].args.join(' '));
    process.exit(1);
});
commander_1["default"].command('help').action(function () { return commander_1["default"].outputHelp(); });
commander_1["default"].parse(process.argv);
if (commander_1["default"].args.length === 0)
    commander_1["default"].outputHelp();
