"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __asyncValues = (this && this.__asyncValues) || function (o) {
    if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
    var m = o[Symbol.asyncIterator], i;
    return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
    function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
    function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
exports.__esModule = true;
var ora_1 = __importDefault(require("ora"));
var config_1 = require("./util/config");
var cross_spawn_1 = __importDefault(require("cross-spawn"));
var chalk_1 = __importDefault(require("chalk"));
var stringio_1 = require("@rauschma/stringio");
var graphql_1 = require("./util/graphql");
function submit(challengeID, executable, args, cmd) {
    return __awaiter(this, void 0, void 0, function () {
        var token, spinner, c, data, error_1, attempt, programSpinner, output, uploadSpinner, resp, error_2, data, error_3, programSpinner, attempt, output, error_4;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    token = config_1.config.get('token');
                    spinner = ora_1["default"]('Getting data').start();
                    c = graphql_1.client(token);
                    if (!cmd.live) return [3 /*break*/, 10];
                    data = void 0;
                    _a.label = 1;
                case 1:
                    _a.trys.push([1, 3, , 4]);
                    return [4 /*yield*/, c.request("\n          mutation GenerateLiveAttempt($challenge: ID!) {\n            generateAttempt(challenge: $challenge, live: true) {\n              id\n              input {\n                arguments\n                stdin\n              }\n            }\n          }\n        ", { challenge: challengeID })];
                case 2:
                    data = _a.sent();
                    return [3 /*break*/, 4];
                case 3:
                    error_1 = _a.sent();
                    if (error_1.message.includes('max attempts')) {
                        spinner.fail("You have reached the maximum allowed attempts for this challenge.");
                    }
                    else {
                        spinner.fail("Fetching data failed: " + error_1.message);
                    }
                    return [2 /*return*/];
                case 4:
                    if (!data || !data.generateAttempt) {
                        spinner.fail("No data recieved: " + data);
                        return [2 /*return*/];
                    }
                    attempt = data.generateAttempt;
                    spinner.succeed('Recieved data');
                    programSpinner = ora_1["default"]('Running program').start();
                    return [4 /*yield*/, run(executable, args, attempt.input)];
                case 5:
                    output = _a.sent();
                    programSpinner.succeed('Finished running');
                    uploadSpinner = ora_1["default"]('Uploading results').start();
                    resp = void 0;
                    _a.label = 6;
                case 6:
                    _a.trys.push([6, 8, , 9]);
                    return [4 /*yield*/, c.request("\n        mutation SubmitLiveAttempt($attempt: ID!, $stdout: String!, $stderr: String!) {\n          submitAttempt(attempt: $attempt, stdout: $stdout, stderr: $stderr) {\n            submission_date\n          }\n        }\n      ", {
                            attempt: attempt.id,
                            stdout: output.stdout,
                            stderr: output.stderr
                        })];
                case 7:
                    resp = _a.sent();
                    return [3 /*break*/, 9];
                case 8:
                    error_2 = _a.sent();
                    spinner.fail("Submission failed with error: " + error_2.message);
                    return [2 /*return*/];
                case 9:
                    if (!resp || !resp.submitAttempt) {
                        spinner.fail("Submission recieved no response data: " + resp);
                        return [2 /*return*/];
                    }
                    uploadSpinner.succeed("Server recieved results at " + new Date(resp.submitAttempt.submission_date).toLocaleString() + ".");
                    return [3 /*break*/, 18];
                case 10:
                    data = void 0;
                    _a.label = 11;
                case 11:
                    _a.trys.push([11, 13, , 14]);
                    return [4 /*yield*/, c.request("\n          mutation GenerateTestAttempt($challenge: ID!) {\n            generateAttempt(challenge: $challenge, live: false) {\n              id\n              input {\n                arguments\n                stdin\n              }\n              expected_output {\n                stdout\n                stderr\n              }\n            }\n          }\n        ", { challenge: challengeID })];
                case 12:
                    data = _a.sent();
                    return [3 /*break*/, 14];
                case 13:
                    error_3 = _a.sent();
                    spinner.fail("Submission failed with error: " + error_3.message);
                    return [2 /*return*/];
                case 14:
                    spinner.succeed('Recieved data');
                    programSpinner = ora_1["default"]('Running program').start();
                    attempt = data.generateAttempt;
                    _a.label = 15;
                case 15:
                    _a.trys.push([15, 17, , 18]);
                    return [4 /*yield*/, run(executable, args, attempt.input)];
                case 16:
                    output = _a.sent();
                    if (output.stdout != attempt.expected_output.stdout) {
                        programSpinner.fail('Stdout does not match');
                        console.log(chalk_1["default"].bold('Stdout should be'));
                        console.log(attempt.expected_output.stdout);
                        console.log(chalk_1["default"].bold('but is'));
                        console.log(output.stdout);
                        return [2 /*return*/];
                    }
                    if (output.stderr != attempt.expected_output.stderr) {
                        programSpinner.fail('Stderr does not match');
                        console.log(chalk_1["default"].bold('Stderr should be'));
                        console.log(attempt.expected_output.stderr);
                        console.log(chalk_1["default"].bold('but is'));
                        console.log(output.stderr);
                        return [2 /*return*/];
                    }
                    programSpinner.succeed('Test succeded');
                    return [3 /*break*/, 18];
                case 17:
                    error_4 = _a.sent();
                    programSpinner.fail('Running test failed: ' + error_4.message);
                    return [3 /*break*/, 18];
                case 18: return [2 /*return*/];
            }
        });
    });
}
exports["default"] = submit;
function run(executable, args, input) {
    var e_1, _a, e_2, _b;
    return __awaiter(this, void 0, void 0, function () {
        var proc, stdout, _c, _d, line, e_1_1, stderr, _e, _f, line, e_2_1;
        return __generator(this, function (_g) {
            switch (_g.label) {
                case 0:
                    proc = cross_spawn_1["default"](executable, args.concat(input.arguments), {
                        stdio: ['pipe', 'pipe', 'pipe']
                    });
                    if (!proc.stdin) return [3 /*break*/, 3];
                    return [4 /*yield*/, stringio_1.streamWrite(proc.stdin, input.stdin)];
                case 1:
                    _g.sent();
                    return [4 /*yield*/, stringio_1.streamEnd(proc.stdin)];
                case 2:
                    _g.sent();
                    _g.label = 3;
                case 3:
                    stdout = '';
                    if (!proc.stdout) return [3 /*break*/, 15];
                    _g.label = 4;
                case 4:
                    _g.trys.push([4, 9, 10, 15]);
                    _c = __asyncValues(stringio_1.chunksToLinesAsync(proc.stdout));
                    _g.label = 5;
                case 5: return [4 /*yield*/, _c.next()];
                case 6:
                    if (!(_d = _g.sent(), !_d.done)) return [3 /*break*/, 8];
                    line = _d.value;
                    stdout += stringio_1.chomp(line);
                    _g.label = 7;
                case 7: return [3 /*break*/, 5];
                case 8: return [3 /*break*/, 15];
                case 9:
                    e_1_1 = _g.sent();
                    e_1 = { error: e_1_1 };
                    return [3 /*break*/, 15];
                case 10:
                    _g.trys.push([10, , 13, 14]);
                    if (!(_d && !_d.done && (_a = _c["return"]))) return [3 /*break*/, 12];
                    return [4 /*yield*/, _a.call(_c)];
                case 11:
                    _g.sent();
                    _g.label = 12;
                case 12: return [3 /*break*/, 14];
                case 13:
                    if (e_1) throw e_1.error;
                    return [7 /*endfinally*/];
                case 14: return [7 /*endfinally*/];
                case 15:
                    stderr = '';
                    if (!proc.stderr) return [3 /*break*/, 27];
                    _g.label = 16;
                case 16:
                    _g.trys.push([16, 21, 22, 27]);
                    _e = __asyncValues(stringio_1.chunksToLinesAsync(proc.stderr));
                    _g.label = 17;
                case 17: return [4 /*yield*/, _e.next()];
                case 18:
                    if (!(_f = _g.sent(), !_f.done)) return [3 /*break*/, 20];
                    line = _f.value;
                    stderr += stringio_1.chomp(line);
                    _g.label = 19;
                case 19: return [3 /*break*/, 17];
                case 20: return [3 /*break*/, 27];
                case 21:
                    e_2_1 = _g.sent();
                    e_2 = { error: e_2_1 };
                    return [3 /*break*/, 27];
                case 22:
                    _g.trys.push([22, , 25, 26]);
                    if (!(_f && !_f.done && (_b = _e["return"]))) return [3 /*break*/, 24];
                    return [4 /*yield*/, _b.call(_e)];
                case 23:
                    _g.sent();
                    _g.label = 24;
                case 24: return [3 /*break*/, 26];
                case 25:
                    if (e_2) throw e_2.error;
                    return [7 /*endfinally*/];
                case 26: return [7 /*endfinally*/];
                case 27: return [4 /*yield*/, new Promise(function (resolve) { return proc.addListener('exit', function () { return resolve(); }); })];
                case 28:
                    _g.sent();
                    return [2 /*return*/, {
                            stdout: stdout,
                            stderr: stderr
                        }];
            }
        });
    });
}
